[project]
name = "tcblib"
version = "0.1.3"
description = "Library and app for controlling 'test-control-board-1' manufactured by embeddedlinux.pl"
readme = "README.md"
license = { file = "LICENSE" }
requires-python = ">=3.10"
authors = [
    { name = "Grzegorz Heldt", email = "grzegorz.heldt@embeddedlinux.pl" },
]

dependencies = [
    "modbus-tk",
    "pyserial"
]

[project.optional-dependencies]
dev = [
    "black",
    "build",
    "isort[colors]",
    "mypy",
    "pylint",
    "twine",
    "types-pyserial"
]

[project.scripts]
tcb-tool = "tcblib.tcb_tool:main"

[project.urls]
homepage = "https://gitlab.com/embeddedlinux/tools/test-control-board-1/test-control-board-1-lib"
repository = "https://gitlab.com/embeddedlinux/tools/test-control-board-1/test-control-board-1-lib"
bugtracker = "https://gitlab.com/embeddedlinux/tools/test-control-board-1/test-control-board-1-lib/-/issues"

[build-system]
requires = ["setuptools"]
build-backend = "setuptools.build_meta"

[tool.black]
line-length = 120

[tool.isort]
line_length = 120
profile = "black"

[tool.mypy]
disallow_untyped_defs = true
enable_error_code = ["redundant-expr"]
implicit_reexport = true
pretty = true
show_error_codes = true
strict = true
strict_equality = true
warn_no_return = true
warn_redundant_casts = true
warn_unreachable = true

[tool.pylint.format]
max-line-length = 120

[tool.pylint.messages_control]
disable = [
    "logging-fstring-interpolation",
    "missing-class-docstring",
    "missing-function-docstring",
    "missing-module-docstring"
]
